diff --git a/oflog/include/dcmtk/oflog/helpers/snprintf.h b/oflog/include/dcmtk/oflog/helpers/snprintf.h
new file mode 100644
index 0000000..e27e632
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/helpers/snprintf.h
@@ -0,0 +1,63 @@
+// -*- C++ -*-
+//  Copyright (C) 2010-2012, Vaclav Zeman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#ifndef DCMTK_LOG4CPLUS_HELPERS_SNPRINTF_H
+#define DCMTK_LOG4CPLUS_HELPERS_SNPRINTF_H
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#include "dcmtk/oflog/tchar.h"
+#include <cstdarg>
+#include "dcmtk/ofstd/ofvector.h"
+
+
+namespace dcmtk {
+namespace log4cplus { namespace helpers {
+
+
+class DCMTK_LOG4CPLUS_EXPORT snprintf_buf
+{
+public:
+    snprintf_buf ();
+
+    tchar const * print (tchar const * fmt, ...)
+        DCMTK_LOG4CPLUS_FORMAT_ATTRIBUTE (__printf__, 2, 3);
+    tchar const * print_va_list (tchar const * fmt, va_list)
+        DCMTK_LOG4CPLUS_FORMAT_ATTRIBUTE (__printf__, 2, 0);
+
+private:
+    OFVector<tchar> buf;
+};
+  
+
+} } // namespace log4cplus { namespace helpers
+} // end namespace dcmtk
+
+
+
+#endif // DCMTK_LOG4CPLUS_HELPERS_SNPRINTF_H
diff --git a/oflog/include/dcmtk/oflog/helpers/sockbuff.h b/oflog/include/dcmtk/oflog/helpers/sockbuff.h
index 96e4b64..35b3268 100644
--- a/oflog/include/dcmtk/oflog/helpers/sockbuff.h
+++ b/oflog/include/dcmtk/oflog/helpers/sockbuff.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    socketbuffer.h
 // Created: 5/2003
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -24,58 +25,57 @@
 #define DCMTK_LOG4CPLUS_HELPERS_SOCKET_BUFFER_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/tstring.h"
-#include "dcmtk/oflog/helpers/lloguser.h"
 
 
 namespace dcmtk {
 namespace log4cplus {
-    namespace helpers {
+namespace helpers {
 
-        /**
-         *
-         */
-        class DCMTK_LOG4CPLUS_EXPORT SocketBuffer : protected LogLogUser
-        {
-        public:
-            SocketBuffer(size_t max);
-            SocketBuffer(const SocketBuffer& rhs);
-            ~SocketBuffer();
+/**
+ *
+ */
+class DCMTK_LOG4CPLUS_EXPORT SocketBuffer
+{
+public:
+    explicit SocketBuffer(size_t max);
+    virtual ~SocketBuffer();
 
-            SocketBuffer& operator=(const SocketBuffer& rhs);
+    char *getBuffer() const { return buffer; }
+    size_t getMaxSize() const { return maxsize; }
+    size_t getSize() const { return size; }
+    void setSize(size_t s) { size = s; }
+    size_t getPos() const { return pos; }
 
-            char *getBuffer() const { return buffer; }
-            size_t getMaxSize() const { return maxsize; }
-            size_t getSize() const { return size; }
-            void setSize(size_t s) { size = s; }
-            size_t getPos() const { return pos; }
+    unsigned char readByte();
+    unsigned short readShort();
+    unsigned int readInt();
+    tstring readString(unsigned char sizeOfChar);
 
-            unsigned char readByte();
-            unsigned short readShort();
-            unsigned int readInt();
-            tstring readString(unsigned char sizeOfChar);
+    void appendByte(unsigned char val);
+    void appendShort(unsigned short val);
+    void appendInt(unsigned int val);
+    void appendString(const tstring& str);
+    void appendBuffer(const SocketBuffer& buffer);
 
-            void appendByte(unsigned char val);
-            void appendShort(unsigned short val);
-            void appendInt(unsigned int val);
-            void appendSize_t(size_t val);
-            void appendString(const tstring& str);
-            void appendBuffer(const SocketBuffer& buffer);
+private:
+    // Data
+    size_t maxsize;
+    size_t size;
+    size_t pos;
+    char *buffer;
 
-        private:
-          // Methods
-            void copy(const SocketBuffer& rhs);
+    SocketBuffer(SocketBuffer const & rhs);
+    SocketBuffer& operator= (SocketBuffer const& rhs);
+};
 
-          // Data
-            size_t maxsize;
-            size_t size;
-            size_t pos;
-            char *buffer;
-        };
-
-    } // end namespace helpers
+} // end namespace helpers
 } // end namespace log4cplus
 } // end namespace dcmtk
 
 #endif // DCMTK_LOG4CPLUS_HELPERS_SOCKET_HEADER_
-
diff --git a/oflog/include/dcmtk/oflog/helpers/socket.h b/oflog/include/dcmtk/oflog/helpers/socket.h
index cfd9dc8..2b27a0d 100644
--- a/oflog/include/dcmtk/oflog/helpers/socket.h
+++ b/oflog/include/dcmtk/oflog/helpers/socket.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    socket.h
 // Created: 4/2003
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -24,11 +25,15 @@
 #define DCMTK_LOG4CPLUS_HELPERS_SOCKET_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/tstring.h"
 #include "dcmtk/oflog/helpers/sockbuff.h"
-#if defined(_WIN32)
-#include <winsock.h>
-#endif
+#include <cstddef> // ptrdiff_t
+
 
 namespace dcmtk {
 namespace log4cplus {
@@ -38,19 +43,14 @@ namespace log4cplus {
                            not_opened,
                            bad_address,
                            connection_failed,
-                           broken_pipe,
+                           broken_pipe, 
                            invalid_access_mode,
                            message_truncated
                          };
 
-#if !defined(_WIN32)
-        typedef int SOCKET_TYPE;
-#ifndef INVALID_SOCKET
-#define INVALID_SOCKET -1
-#endif
-#else
-        typedef SOCKET SOCKET_TYPE;
-#endif
+        typedef ptrdiff_t SOCKET_TYPE;
+
+        extern DCMTK_LOG4CPLUS_EXPORT SOCKET_TYPE const INVALID_SOCKET_VALUE;
 
         class DCMTK_LOG4CPLUS_EXPORT AbstractSocket {
         public:
@@ -88,12 +88,13 @@ namespace log4cplus {
           // ctor and dtor
             Socket();
             Socket(SOCKET_TYPE sock, SocketState state, int err);
-            Socket(const tstring& address, int port);
+            Socket(const tstring& address, unsigned short port, bool udp = false);
             virtual ~Socket();
 
           // methods
             virtual bool read(SocketBuffer& buffer);
             virtual bool write(const SocketBuffer& buffer);
+            virtual bool write(const STD_NAMESPACE string & buffer);
         };
 
 
@@ -107,7 +108,7 @@ namespace log4cplus {
         class DCMTK_LOG4CPLUS_EXPORT ServerSocket : public AbstractSocket {
         public:
           // ctor and dtor
-            ServerSocket(int port);
+            ServerSocket(unsigned short port);
             virtual ~ServerSocket();
 
             Socket accept();
@@ -115,15 +116,20 @@ namespace log4cplus {
 
 
         DCMTK_LOG4CPLUS_EXPORT SOCKET_TYPE openSocket(unsigned short port, SocketState& state);
-        DCMTK_LOG4CPLUS_EXPORT SOCKET_TYPE connectSocket(const tstring& hostn,
-                                                   unsigned short port, SocketState& state);
+        DCMTK_LOG4CPLUS_EXPORT SOCKET_TYPE connectSocket(const log4cplus::tstring& hostn,
+                                                   unsigned short port, bool udp,
+                                                   SocketState& state);
         DCMTK_LOG4CPLUS_EXPORT SOCKET_TYPE acceptSocket(SOCKET_TYPE sock, SocketState& state);
         DCMTK_LOG4CPLUS_EXPORT int closeSocket(SOCKET_TYPE sock);
 
         DCMTK_LOG4CPLUS_EXPORT long read(SOCKET_TYPE sock, SocketBuffer& buffer);
-        DCMTK_LOG4CPLUS_EXPORT long write(SOCKET_TYPE sock, const SocketBuffer& buffer);
+        DCMTK_LOG4CPLUS_EXPORT long write(SOCKET_TYPE sock,
+            const SocketBuffer& buffer);
+        DCMTK_LOG4CPLUS_EXPORT long write(SOCKET_TYPE sock,
+            const STD_NAMESPACE string & buffer);
 
         DCMTK_LOG4CPLUS_EXPORT tstring getHostname (bool fqdn);
+        DCMTK_LOG4CPLUS_EXPORT int setTCPNoDelay (SOCKET_TYPE, bool);
 
     } // end namespace helpers
 } // end namespace log4cplus
diff --git a/oflog/include/dcmtk/oflog/helpers/strhelp.h b/oflog/include/dcmtk/oflog/helpers/strhelp.h
index 3e1ee25..62a9870 100644
--- a/oflog/include/dcmtk/oflog/helpers/strhelp.h
+++ b/oflog/include/dcmtk/oflog/helpers/strhelp.h
@@ -1,3 +1,4 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    stringhelper.h
 // Created: 3/2003
@@ -24,12 +25,16 @@
 #define DCMTK_LOG4CPLUS_HELPERS_STRINGHELPER_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/tstring.h"
-#include "dcmtk/ofstd/oflist.h"
+#include "dcmtk/ofstd/ofvector.h"
 
 //#include <algorithm>
 //#include <limits>
-//#include <iterator>
 
 
 namespace dcmtk {
@@ -39,13 +44,13 @@ namespace log4cplus {
         /**
          * Returns <code>s</code> in upper case.
          */
-        DCMTK_LOG4CPLUS_EXPORT tstring toUpper(const tstring& s);
+        DCMTK_LOG4CPLUS_EXPORT log4cplus::tstring toUpper(const log4cplus::tstring& s);
 
 
         /**
          * Returns <code>s</code> in lower case.
          */
-        DCMTK_LOG4CPLUS_EXPORT tstring toLower(const tstring& s);
+        DCMTK_LOG4CPLUS_EXPORT log4cplus::tstring toLower(const log4cplus::tstring& s);
 
 
         /**
@@ -65,7 +70,7 @@ namespace log4cplus {
         inline
         void
         tokenize(const StringType& s, typename StringType::value_type c,
-            OFList<StringType>& result, bool collapseTokens = true)
+            OFVector<StringType>& result, bool collapseTokens = true)
         {
             typedef typename StringType::size_type size_type;
             size_type const slen = s.length();
@@ -117,15 +122,22 @@ namespace log4cplus {
                 if (value == minVal)
                 {
                     intType const r = value / 10;
-                    intType const a = (0-r) * 10;
-                    intType const mod = 0-(a + value);
-                    value = 0-r;
+                    intType const a = (-r) * 10;
+                    intType const mod = -(a + value);
+                    value = -r;
 
-                    *(it - 1) = OFstatic_cast(tchar, DCMTK_LOG4CPLUS_TEXT('0') + mod);
+                    *(it - 1) = DCMTK_LOG4CPLUS_TEXT('0') + OFstatic_cast(tchar, mod);
                     --it;
                 }
                 else
-                    value = 0-value;
+                    value = -value;
+            }
+
+            static inline
+            bool
+            is_negative (intType val)
+            {
+                return val < 0;
             }
         };
 
@@ -135,18 +147,22 @@ namespace log4cplus {
         void
         convertIntegerToString (tstring & str, intType value)
         {
-            if (value == 0)
-                str = DCMTK_LOG4CPLUS_TEXT("0");
-            // We can't use (value < 0) because that could cause a compiler
-            // warning for unsigned types.
-            bool const negative = !(value > 0 || value == 0);
-
             const size_t buffer_size = 30; // More than enough space, even for 64 bit integers
                 // = intTypeLimits::digits10 + 2;
             tchar buffer[buffer_size];
             tchar * it = &buffer[buffer_size];
             tchar const * const buf_end = it;
 
+            if (value == 0)
+            {
+                --it;
+                *it = DCMTK_LOG4CPLUS_TEXT('0');
+            }
+
+            // We can't use (value < 0) because that could cause a compiler
+            // warning for unsigned types.
+            const OFBool isUnsigned = (OFstatic_cast(intType, -1) < 0) ? OFFalse : OFTrue;
+            bool const negative = !(value > 0 || isUnsigned || value == 0);
             if (negative)
                 ConvertIntegerToStringHelper<intType>::step1(it, value);
 
@@ -154,7 +170,7 @@ namespace log4cplus {
             {
                 intType mod = value % 10;
                 value = value / 10;
-                *(it - 1) = OFstatic_cast(tchar, DCMTK_LOG4CPLUS_TEXT('0') + mod);
+                *(it - 1) = DCMTK_LOG4CPLUS_TEXT('0') + OFstatic_cast(tchar, mod);
             }
 
             if (negative)
@@ -163,7 +179,7 @@ namespace log4cplus {
                 *it = DCMTK_LOG4CPLUS_TEXT('-');
             }
 
-            str.assign (OFstatic_cast(tchar const *, it), buf_end - it);
+            str.assign (OFstatic_cast(tchar const *, it), buf_end);
         }
 
 
@@ -180,6 +196,6 @@ namespace log4cplus {
     } // namespace helpers
 
 } // namespace log4cplus
-} // namespace dcmtk
+} // end namespace dcmtk
 
 #endif // DCMTK_LOG4CPLUS_HELPERS_STRINGHELPER_HEADER_
diff --git a/oflog/include/dcmtk/oflog/helpers/threadcf.h b/oflog/include/dcmtk/oflog/helpers/threadcf.h
index 0323115..587a8ae 100644
--- a/oflog/include/dcmtk/oflog/helpers/threadcf.h
+++ b/oflog/include/dcmtk/oflog/helpers/threadcf.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    thread-config.h
 // Created: 4/2003
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -22,127 +23,39 @@
 #ifndef DCMTK_LOG4CPLUS_HELPERS_THREAD_CONFIG_HEADER_
 #define DCMTK_LOG4CPLUS_HELPERS_THREAD_CONFIG_HEADER_
 
-#define INCLUDE_CSTDDEF               /* For NULL */
-#include "dcmtk/ofstd/ofstdinc.h"
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
 
-#ifdef DCMTK_LOG4CPLUS_USE_PTHREADS
-#   include <pthread.h>
-#   include <semaphore.h>
-#   define DCMTK_LOG4CPLUS_MUTEX_PTR_DECLARE pthread_mutex_t*
-#   define DCMTK_LOG4CPLUS_MUTEX_CREATE ::dcmtk::log4cplus::thread::createNewMutex()
-#   define DCMTK_LOG4CPLUS_MUTEX_LOCK(mutex) pthread_mutex_lock(mutex)
-#   define DCMTK_LOG4CPLUS_MUTEX_UNLOCK(mutex) pthread_mutex_unlock(mutex)
-#   define DCMTK_LOG4CPLUS_MUTEX_FREE(mutex) ::dcmtk::log4cplus::thread::deleteMutex(mutex)
-#   define DCMTK_LOG4CPLUS_THREAD_HANDLE_TYPE  pthread_t
-#   define DCMTK_LOG4CPLUS_THREAD_KEY_TYPE pthread_t
-#   define DCMTK_LOG4CPLUS_GET_CURRENT_THREAD_NAME \
-    ::dcmtk::log4cplus::thread::getCurrentThreadName()
-#   define DCMTK_LOG4CPLUS_GET_CURRENT_THREAD pthread_self()
-#   define DCMTK_LOG4CPLUS_THREAD_LOCAL_TYPE pthread_key_t*
-#   define DCMTK_LOG4CPLUS_THREAD_LOCAL_INIT(cleanup) \
-    ::dcmtk::log4cplus::thread::createPthreadKey(cleanup)
-#   define DCMTK_LOG4CPLUS_GET_THREAD_LOCAL_VALUE(key) pthread_getspecific(*(key))
-#   define DCMTK_LOG4CPLUS_SET_THREAD_LOCAL_VALUE(key, value) \
-    pthread_setspecific(*(key), value)
-#   define DCMTK_LOG4CPLUS_THREAD_LOCAL_CLEANUP(key) \
-    do { pthread_key_t * pthkey (key); pthread_key_delete(*pthkey); \
-    delete pthkey; } while(0)
-namespace dcmtk {
-namespace log4cplus {
-    namespace thread {
-        DCMTK_LOG4CPLUS_EXPORT DCMTK_LOG4CPLUS_MUTEX_PTR_DECLARE createNewMutex();
-        DCMTK_LOG4CPLUS_EXPORT void deleteMutex(DCMTK_LOG4CPLUS_MUTEX_PTR_DECLARE);
-        DCMTK_LOG4CPLUS_EXPORT DCMTK_LOG4CPLUS_THREAD_LOCAL_TYPE createPthreadKey(void (*) (void *));
-    }
-}
-}
+#if defined (DCMTK_LOG4CPLUS_USE_PTHREADS)
+#   if defined (__APPLE__)
+#     define DCMTK_LOG4CPLUS_USE_NAMED_POSIX_SEMAPHORE
+#   endif
 
 #elif defined(DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
-#   undef WIN32_LEAN_AND_MEAN
-#   define WIN32_LEAN_AND_MEAN
-#   include <windows.h>
-
-#   define DCMTK_LOG4CPLUS_MUTEX_PTR_DECLARE CRITICAL_SECTION*
-#   define DCMTK_LOG4CPLUS_MUTEX_CREATE ::dcmtk::log4cplus::thread::createNewMutex()
-#   define DCMTK_LOG4CPLUS_MUTEX_LOCK(mutex)  EnterCriticalSection(mutex)
-#   define DCMTK_LOG4CPLUS_MUTEX_UNLOCK(mutex)  LeaveCriticalSection(mutex)
-#   define DCMTK_LOG4CPLUS_MUTEX_FREE(mutex) ::dcmtk::log4cplus::thread::deleteMutex(mutex)
-
-#   define DCMTK_LOG4CPLUS_THREAD_HANDLE_TYPE  HANDLE
-#   define DCMTK_LOG4CPLUS_THREAD_KEY_TYPE  DWORD
-#   define DCMTK_LOG4CPLUS_GET_CURRENT_THREAD  GetCurrentThreadId()
-#   define DCMTK_LOG4CPLUS_GET_CURRENT_THREAD_NAME \
-    ::dcmtk::log4cplus::thread::getCurrentThreadName()
-#   define DCMTK_LOG4CPLUS_THREAD_LOCAL_TYPE DWORD
-#   define DCMTK_LOG4CPLUS_THREAD_LOCAL_INIT(cleanup) TlsAlloc()
-#   define DCMTK_LOG4CPLUS_GET_THREAD_LOCAL_VALUE(key) TlsGetValue(key)
-#   define DCMTK_LOG4CPLUS_SET_THREAD_LOCAL_VALUE(key, value) \
-    TlsSetValue(key, OFstatic_cast(LPVOID, value))
-#   define DCMTK_LOG4CPLUS_THREAD_LOCAL_CLEANUP(key) TlsFree(key)
-#   if defined (_MSC_VER)
-#     undef DCMTK_LOG4CPLUS_HAVE_TLS_SUPPORT
-#     undef DCMTK_LOG4CPLUS_THREAD_LOCAL_VAR
-// Comment out the following two lines if you do intend to use log4cplus.dll
-// for loading using LoadLibrary(). The __declspec(thread) functionality is not
-// compatible with such DLL use. For more information why is this necessary see
-// <http://msdn.microsoft.com/en-us/library/2s9wt68x(vs.80).aspx>.
+#   if defined (_WIN32_WINNT) && _WIN32_WINNT >= 0x0600
+#     define DCMTK_LOG4CPLUS_USE_SRW_LOCK
+#   else
+#     define DCMTK_LOG4CPLUS_POOR_MANS_SHAREDMUTEX
+#   endif
+#   undef DCMTK_LOG4CPLUS_HAVE_TLS_SUPPORT
+#   undef DCMTK_LOG4CPLUS_THREAD_LOCAL_VAR
+#   if defined (_MSC_VER) && _WIN32_WINNT >= 0x0600
+// The __declspec(thread) functionality is not compatible with LoadLibrary().
+// For more information why see and "Windows and TLS" note in README.
+// <http://msdn.microsoft.com/en-us/library/2s9wt68x(v=vs.100).aspx>.
 #     define DCMTK_LOG4CPLUS_HAVE_TLS_SUPPORT 1
 #     define DCMTK_LOG4CPLUS_THREAD_LOCAL_VAR __declspec(thread)
 #   endif
 
-
-namespace dcmtk {
-namespace log4cplus { namespace thread {
-
-DCMTK_LOG4CPLUS_EXPORT DCMTK_LOG4CPLUS_MUTEX_PTR_DECLARE createNewMutex();
-DCMTK_LOG4CPLUS_EXPORT void deleteMutex(DCMTK_LOG4CPLUS_MUTEX_PTR_DECLARE);
-
-} } } // namespace dcmtk { namespace log4cplus { namespace thread { /
-
 #elif defined(DCMTK_LOG4CPLUS_SINGLE_THREADED)
-#   define DCMTK_LOG4CPLUS_MUTEX_PTR_DECLARE int*
-#   define DCMTK_LOG4CPLUS_MUTEX_CREATE NULL
-#   define DCMTK_LOG4CPLUS_MUTEX_LOCK(mutex)
-#   define DCMTK_LOG4CPLUS_MUTEX_UNLOCK(mutex)
-#   define DCMTK_LOG4CPLUS_MUTEX_FREE(mutex)
-#   define DCMTK_LOG4CPLUS_THREAD_HANDLE_TYPE  void *
-#   define DCMTK_LOG4CPLUS_THREAD_KEY_TYPE int
-#   define DCMTK_LOG4CPLUS_GET_CURRENT_THREAD 1
-#   define DCMTK_LOG4CPLUS_GET_CURRENT_THREAD_NAME \
-    DCMTK_LOG4CPLUS_C_STR_TO_TSTRING("single")
-#   define DCMTK_LOG4CPLUS_THREAD_LOCAL_TYPE void*
-#   define DCMTK_LOG4CPLUS_THREAD_LOCAL_INIT(cleanup) NULL
-#   define DCMTK_LOG4CPLUS_GET_THREAD_LOCAL_VALUE(key) (key)
-#   define DCMTK_LOG4CPLUS_SET_THREAD_LOCAL_VALUE(key, value) \
-    do { (key) = (value); } while (0)
-#   define DCMTK_LOG4CPLUS_THREAD_LOCAL_CLEANUP(key) do { (key) = NULL; } while (0)
 #   undef DCMTK_LOG4CPLUS_HAVE_TLS_SUPPORT
 #   undef DCMTK_LOG4CPLUS_THREAD_LOCAL_VAR
 
 #else
 #   error "You Must define a Threading model"
-#endif
 
-/**
- * @def DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX(mutex)
- * Begin a block synchronized on a mutex.
- *
- * @see DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX
- *
- * @def DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX
- * End a block synchronized on a mutex.
- *
- * @see DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX
- */
-#ifndef DCMTK_LOG4CPLUS_SINGLE_THREADED
-#  define DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX(mutex) \
-             do { ::dcmtk::log4cplus::thread::Guard _sync_guard_object(mutex);
-#else
-#  define DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX(mutex) do { (void)(mutex);
 #endif
 
-#define DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX } while (0)
-
 
 #endif // DCMTK_LOG4CPLUS_HELPERS_THREAD_CONFIG_HEADER_
-
diff --git a/oflog/include/dcmtk/oflog/helpers/timehelp.h b/oflog/include/dcmtk/oflog/helpers/timehelp.h
index 0f8bb92..9465756 100644
--- a/oflog/include/dcmtk/oflog/helpers/timehelp.h
+++ b/oflog/include/dcmtk/oflog/helpers/timehelp.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    timehelper.h
 // Created: 6/2003
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,27 +21,36 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_HELPERS_TIME_HELPER_HEADER_
-#define DCMTK__LOG4CPLUS_HELPERS_TIME_HELPER_HEADER_
+#ifndef DCMTK_LOG4CPLUS_HELPERS_TIME_HELPER_HEADER_
+#define DCMTK_LOG4CPLUS_HELPERS_TIME_HELPER_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/tstring.h"
 
-#ifdef TM_IN_SYS_TIME
-#include <sys/time.h>
+#if defined (DCMTK_LOG4CPLUS_HAVE_TIME_H)
+#include <time.h>
 #endif
 
-//#include <time.h>
-#define INCLUDE_CTIME
-#include "dcmtk/ofstd/ofstdinc.h"
+#include <ctime>
 
 
 namespace dcmtk {
-
 namespace log4cplus {
 
 namespace helpers {
 
+
+#if 0 // Needed for MSC6
+using STD_NAMESPACE time_t;
+using STD_NAMESPACE tm;
+#endif
+
+
 /**
  * This class represents a Epoch time with microsecond accuracy.
  */
@@ -52,7 +62,7 @@ public:
 
     /**
      * Returns the current time using the <code>gettimeofday()</code>
-     * method if it is available on the current platform.  (Not on
+     * method if it is available on the current platform.  (Not on 
      * WIN32.)
      */
     static Time gettimeofday();
@@ -81,39 +91,39 @@ public:
     /**
      * Sets this Time using the <code>mktime</code> function.
      */
-    time_t setTime(struct tm* t);
+    time_t setTime(tm* t);
 
     /**
-     * Returns this Time as a <code>time_t></code> value.
+     * Returns this Time as a <code>time_t</code> value.
      */
-    time_t getTime() const;
+    time_t getTime() const DCMTK_LOG4CPLUS_ATTRIBUTE_PURE;
 
     /**
      * Populates <code>tm</code> using the <code>gmtime()</code>
      * function.
      */
-    void gmtime(struct tm* t) const;
+    void gmtime(tm* t) const;
 
     /**
      * Populates <code>tm</code> using the <code>localtime()</code>
      * function.
      */
-    void localtime(struct tm* t) const;
+    void localtime(tm* t) const;
 
     /**
      * Returns a string with a "formatted time" specified by
      * <code>fmt</code>.  It used the <code>strftime()</code>
-     * function to do this.
-     *
+     * function to do this.  
+     * 
      * Look at your platform's <code>strftime()</code> documentation
      * for the formatting options available.
-     *
+     * 
      * The following additional options are provided:<br>
      * <code>%q</code> - 3 character field that provides milliseconds
-     * <code>%Q</code> - 7 character field that provides fractional
+     * <code>%Q</code> - 7 character field that provides fractional 
      * milliseconds.
      */
-    tstring getFormattedTime(const tstring& fmt,
+    log4cplus::tstring getFormattedTime(const log4cplus::tstring& fmt,
                                         bool use_gmtime = false) const;
 
   // Operators
@@ -123,48 +133,51 @@ public:
     Time& operator*=(long rhs);
 
 private:
-    void build_q_value (tstring & q_str) const;
-    void build_uc_q_value (tstring & uc_q_str) const;
-
   // Data
     time_t tv_sec;  /* seconds */
     long tv_usec;  /* microseconds */
 };
 
 
-DCMTK_LOG4CPLUS_EXPORT const Time operator+
-                                   (const Time& lhs,
-                                    const Time& rhs);
-DCMTK_LOG4CPLUS_EXPORT const Time operator-
-                                   (const Time& lhs,
-                                    const Time& rhs);
-DCMTK_LOG4CPLUS_EXPORT const Time operator/
-                                   (const Time& lhs,
+DCMTK_LOG4CPLUS_EXPORT const log4cplus::helpers::Time operator+
+                                   (const log4cplus::helpers::Time& lhs,
+                                    const log4cplus::helpers::Time& rhs);
+DCMTK_LOG4CPLUS_EXPORT const log4cplus::helpers::Time operator-
+                                   (const log4cplus::helpers::Time& lhs,
+                                    const log4cplus::helpers::Time& rhs);
+DCMTK_LOG4CPLUS_EXPORT const log4cplus::helpers::Time operator/
+                                   (const log4cplus::helpers::Time& lhs,
                                     long rhs);
-DCMTK_LOG4CPLUS_EXPORT const Time operator*
-                                   (const Time& lhs,
+DCMTK_LOG4CPLUS_EXPORT const log4cplus::helpers::Time operator*
+                                   (const log4cplus::helpers::Time& lhs,
                                     long rhs);
 
-DCMTK_LOG4CPLUS_EXPORT bool operator<(const Time& lhs,
-                                const Time& rhs);
-DCMTK_LOG4CPLUS_EXPORT bool operator<=(const Time& lhs,
-                                 const Time& rhs);
-
-DCMTK_LOG4CPLUS_EXPORT bool operator>(const Time& lhs,
-                                const Time& rhs);
-DCMTK_LOG4CPLUS_EXPORT bool operator>=(const Time& lhs,
-                                 const Time& rhs);
-
-DCMTK_LOG4CPLUS_EXPORT bool operator==(const Time& lhs,
-                                 const Time& rhs);
-DCMTK_LOG4CPLUS_EXPORT bool operator!=(const Time& lhs,
-                                 const Time& rhs);
+DCMTK_LOG4CPLUS_EXPORT bool operator<(const log4cplus::helpers::Time& lhs,
+                                const log4cplus::helpers::Time& rhs)
+    DCMTK_LOG4CPLUS_ATTRIBUTE_PURE;
+DCMTK_LOG4CPLUS_EXPORT bool operator<=(const log4cplus::helpers::Time& lhs,
+                                 const log4cplus::helpers::Time& rhs)
+    DCMTK_LOG4CPLUS_ATTRIBUTE_PURE;
+
+DCMTK_LOG4CPLUS_EXPORT bool operator>(const log4cplus::helpers::Time& lhs,
+                                const log4cplus::helpers::Time& rhs)
+    DCMTK_LOG4CPLUS_ATTRIBUTE_PURE;
+DCMTK_LOG4CPLUS_EXPORT bool operator>=(const log4cplus::helpers::Time& lhs,
+                                 const log4cplus::helpers::Time& rhs)
+    DCMTK_LOG4CPLUS_ATTRIBUTE_PURE;
+
+DCMTK_LOG4CPLUS_EXPORT bool operator==(const log4cplus::helpers::Time& lhs,
+                                 const log4cplus::helpers::Time& rhs)
+    DCMTK_LOG4CPLUS_ATTRIBUTE_PURE;
+DCMTK_LOG4CPLUS_EXPORT bool operator!=(const log4cplus::helpers::Time& lhs,
+                                 const log4cplus::helpers::Time& rhs)
+    DCMTK_LOG4CPLUS_ATTRIBUTE_PURE;
 
 } // namespace helpers
 
 } // namespace log4cplus
-} // namespace dcmtk
+} // end namespace dcmtk
 
 
-#endif // DCMTK__LOG4CPLUS_HELPERS_TIME_HELPER_HEADER_
+#endif // DCMTK_LOG4CPLUS_HELPERS_TIME_HELPER_HEADER_
 
